/* Test copy() */
#include "common.h"

int main()
{
	int err, n;
	ovt_t a1, a2;
	obj_t o;

	auto_init(a1);
	auto_init(a2);

	for(n = 0; n < 10; n++) {
		oprintf(&o, "init=%d", n);
		ovt_append(&a2, o);
	}


	printf("I u=%d a=%d\n", a1.used, a1.alloced);
	printf("I u=%d a=%d\n", a2.used, a2.alloced);

	/* enlarge from 0 */
	ovt_copy(&a1, 0, &a2, 4, 3);
	print_arr("enlarge0", &a1);

	/* overwrite from 1 */
	ovt_copy(&a1, 1, &a2, 4, 5);
	print_arr("overwrt1", &a1);

	/* overwrite from 0 */
	ovt_copy(&a1, 0, &a2, 0, 3);
	print_arr("overwrt0", &a1);

	/* src trunc */
	ovt_copy(&a1, 0, &a2, 8, 1000);
	print_arr("strunc  ", &a1);

	/* src beyond */
	err = ovt_copy(&a1, 0, &a2, 10, 10);
	print_arr("sbeyond ", &a1);
	printf("err=%d\n", err);


	/* dst beyond */
	err = ovt_copy(&a1, 8, &a2, 0, 5);
	print_arr("dbeyond ", &a1);

	/* dst beyond: fill the gap */
	err = ovt_copy(&a1, 6, &a2, 8, 2);
	print_arr("fillgap ", &a1);


	/* copy all */
	ovt_truncate(&a1, 0);
	print_arr("copyall1", &a1);
	err = ovt_copy(&a1, 0, &a2, 0, 100);
	print_arr("copyall2", &a1);

	/*** copy within the vector ***/

	/* nop-copy */
	ovt_copy(&a1, 1, &a1, 1, 5);
	print_arr("nop     ", &a1);

	/* overlap */
	ovt_copy(&a1, 1, &a1, 2, 3);
	print_arr("overlap1", &a1);
	ovt_copy(&a1, 7, &a1, 6, 3);
	print_arr("overlap2", &a1);

	ovt_uninit(&a1);
	ovt_uninit(&a2);
	return 0;
}
