#include <assert.h>
#include <string.h>
#include <stdio.h>
#include "obj.h"
#include "ovt.h"

extern int can_not_check_beyond;

#define def_elem_state(gds, elem) \
	int elem ## _idx = (elem - gds->array); \
	char * elem ## _state = &(gds->elem_state[elem ## _idx]);

int obj_constructor(ovt_t *gds, obj_t *elem)
{
	def_elem_state(gds, elem);

	assert(*elem_state == 0);
	assert(elem->cookie != cookie_alloced);
	elem->cookie = cookie_alloced;
	strcpy(elem->str, "<fresh>");
	*elem_state = 1;
	printf(" CNS: construct %d\n", elem_idx);
	return 0;
}

void obj_destructor(ovt_t *gds, obj_t *elem)
{
	def_elem_state(gds, elem);

	if (!can_not_check_beyond)
		assert(*elem_state == 1);
	assert(elem->cookie == cookie_alloced);
	elem->cookie = cookie_deadslot;
	strcpy(elem->str, "<dead>");
	*elem_state = 0;
	printf(" CNS: destruct  %d\n", elem_idx);
}

int obj_copy(ovt_t *dst_gds, obj_t *dst, const obj_t *src)
{
	def_elem_state(dst_gds, dst);

	if (!can_not_check_beyond)
		assert(*dst_state == 0);
	assert(src->cookie == cookie_alloced);
	assert(dst->cookie != cookie_alloced);
	dst->cookie = src->cookie;
	strcpy(dst->str, src->str);
	*dst_state = 1;

	printf(" CNS: copy to   %d\n", dst_idx);
	return 0;
}

